/* Rappel :
 *  un bit a 0 dans un masque = bit toujours accepte, pas de filtrage
 *  un bit a 1 dans masque
 *    . si bit filtre a 0 => bit a 0 du message accepte, bit a 1 refuse
 *    . si bit filtre a 1 => bit a 1 du message accepte, bit a 0 refuse
 * il y a deux masques et six flitres
 *    . le masque 0 (RXM0) est associ� aux flitres 0 et 1 (RXF0 et RXF1) pour le buffer de reception 0 (RXB0)
 *    . le masque 1 (RXM1) est associ� aux filtres 2 a 5 (RXF2 a RXF5)pour le buffer de reception 1 (RXB1)
 */

#ifndef CANBUSINTERFACE_H
#define CANBUSINTERFACE_H

/**************************************************************************
 * LES BIBLIOTHEQUES
 **************************************************************************/

#include <SPI.h>      // la biblioth�que SPI
#include "mcp_can.h"  // la biblioth�que CAN

#define NB_MESSAGES 20  // taille de la file d'attente des messages arrivant du bus CAN
#define RETRY_CONNECTION 10     // nombre de tentative de connection du bus

// DEFINITION D'UN MESSAGE CAN  //
struct messageCAN {
  long unsigned int id;                          // ident du message
  unsigned char len;                            // longueur des donnees
  unsigned char buf[MAX_CHAR_IN_MESSAGE];      // buffer de donnees
};


class CANbusInterface : MCP_CAN
{
    public:
        CANbusInterface(int cs, int baudRate, int idmode);
        virtual ~CANbusInterface();
        bool init(int mask,int filter);
        bool init(int mask0, int filter0, int filter1, int mask1, int filter2, int filter3, int filter4, int filter5);
        void receiveMessage();
        bool readMessage (messageCAN & message);
        int writeMessage (messageCAN message);

    protected:
    private:
        int CS;         // chip select
        int baudrate;
        int ID_mode;

        // LE BUFFER DE RECEPTION DES MESSAGES CAN //
        int indexWrite = 0;                             // index d'ecriture
        int indexRead = 0;                              // index de lecture
        messageCAN BufferReceive[NB_MESSAGES];    // buffer circulaire de reception

};

#endif // CANBUSINTERFACE_H
